﻿Type=StaticCode
Version=1.05
B4J=true
@EndOfDesignText@
Sub Process_Globals
	Private fx As JFX
	Private mainForm As Form

	Private tvPeople As TableView
	Private mnuButton As Node
	Private btnExit As Button

	Private imgBegin As ImageView
	Private imgPrev As ImageView
	Private imgNext As ImageView
	Private imgEnd As ImageView
	
	Private clTv As classTv
	Private tvTimer As Timer
	Private diaResponse As DialogResponses
	Private msgbox As Msgboxes
	Private dbOffset As Int
	

	Private lblName As Label
	Private lblDob As Label
	Private txtName As TextField
	Private txtDob As JFXtrasDateTextField
End Sub

Sub addForm
	tvTimer.Initialize("tvTimer",20)
	tvTimer.Enabled = False
	txtDob.Initialize("txtDob")
	txtDob.DateFormat = "dd/MM/yyyy"
	mainForm.Initialize("mForm",-1,-1)
	mainForm.RootPane.LoadLayout("secondForm")
	mainForm.BackColor = fx.Colors.Blue
	mainForm.Resizable = True
	mainForm.Title = "Second Form"
	tvPeople.SetColumns(Array As String("","","",""))
	tvPeople.SetColumnHeader(0,"Name")
	tvPeople.SetColumnHeader(1,"Dob")
	tvPeople.SetColumnHeader(2,"Age")
	tvPeople.SetColumnVisible(3,False)
	tvPeople.SetColumnSortable(0,False)
	tvPeople.SetColumnSortable(1,False)
	tvPeople.SetColumnSortable(2,False)
	
	clTv.Initialize(tvPeople,"CENTER_LEFT#CENTER_LEFT#CENTER_RIGHT#CENTER")

	mainForm.Show

'	If msgbox.Show2("Want to continue?","Blue Form","Yes","","No") = diaResponse.NEGATIVE Then
'		btnExit_Action
'	End If
	dbOffset = 0
	imgBegin_MouseClicked(Null)
End Sub
Sub mnuButton_Action
	mainForm.Close
	Main.MainFormShow
End Sub
Sub btnExit_Action
	ExitApplication
End Sub



Sub addTvData
	Dim result As String
	Dim s As String
	
	s = "select * from people order by people_name limit '" & clTv.maxrows & "' offset '" & dbOffset & "'"
	Try
		Main.rsTable = Main.sLite.db.ExecQuery(s)
	Catch
		msgbox.Show(LastException,"Db Error during Read")
	End Try
	clTv.clearTable

	Do While Main.rsTable.NextRow
		s = Main.rsTable.GetString("people_name") & "#"
		s = s & gloFuncs.getNormalFromSqlDate(Main.rsTable.GetString("people_dob")) & "#"
		s = s & Main.rsTable.GetString("people_age") & "#"
		s = s & Main.rsTable.GetString("people_recid")

		result = clTv.addrow(s)
		
		If result <> "" Then
			msgbox.Show(result,"Msg from ClassTable")
		End If
	Loop
	'Log("max rows " & clTv.maxrows & " offset" & dbOffset & " tvHeight " & tvPeople.Height)
End Sub

Sub tvPeople_SelectedRowChanged(Index As Int, Row() As Object)
	Dim ap As AnchorPane
	Dim lbl,lbl1,lbl2,lbl3 As Label
	Dim dt As Long

	If Index >= 0 Then
		lbl.Initialize("")
		lbl1.Initialize("")
		lbl2.Initialize("")
		ap = Row(0)
		lbl = ap.GetNode(0)
		ap = Row(1)
		lbl1 = ap.GetNode(0)
		ap = Row(2)
		lbl2 = ap.GetNode(0)
'		ap = Row(3)
'		lbl3 = ap.GetNode(0)
	    'Log("TableView reading column 2 for Index:" & Index & CRLF & " Cell value: " & Row(1))
		'txtData.Text = Index & " " & lbl.Text & " " & lbl1.Text & " " & lbl2.Text & " " & lbl3.Text
		txtName.Text = lbl.Text
		DateTime.DateFormat = "dd/MM/yyyy"
		dt = DateTime.DateParse(lbl1.Text)
		Log("datetime: " & lbl1.Text & " " & dt)
		txtDob.DateFormat = "dd/MM/yyyy"
		txtDob.DateTime = dt
	Else
	
	End If
End Sub
Sub mForm_resize(width As Double,height As Double)
	'============================================================
	'Time must be allowed for any tableView to resize,
	'so use a timer at the end of this code to get it's new size
	'============================================================
	Dim wd,lt,fWidth As Double
	Dim ht,top,fHeight,colWd As Double
	fWidth = mainForm.width
	fHeight = mainForm.height
	mainForm.RootPane.RemoveAllNodes
	ht = fHeight*.025
	wd = fWidth*.4
	top = fHeight*.025
	lt = fWidth*.5 - wd*.5
	mainForm.RootPane.AddNode(mnuButton,lt,top,wd,ht)

	wd = fWidth*.56
	ht = fHeight*.52
	top = fHeight*.15
	lt = fWidth*.22
	mainForm.RootPane.AddNode(tvPeople,lt,top,wd,ht)
	wd = fWidth*.05
	ht = fHeight*.05
	lt = fWidth*.22
	top = fHeight*.1
	mainForm.RootPane.AddNode(imgBegin,lt,top,wd,ht)
	wd = fWidth*.05
	ht = fHeight*.05
	lt = fWidth*.27
	top = fHeight*.1
	mainForm.RootPane.AddNode(imgPrev,lt,top,wd,ht)	
	wd = fWidth*.05
	ht = fHeight*.05
	lt = fWidth*.32
	top = fHeight*.1
	mainForm.RootPane.AddNode(imgNext,lt,top,wd,ht)	
	wd = fWidth*.05
	ht = fHeight*.05
	lt = fWidth*.37
	top = fHeight*.1
	mainForm.RootPane.AddNode(imgEnd,lt,top,wd,ht)	
	wd = fWidth*.1
	lt = fWidth*.9-wd
	ht = fHeight*.025
	top = fHeight*.9 - ht
	mainForm.RootPane.AddNode(btnExit,lt,top,wd,ht)	
	btnExit.Font = fx.DefaultFont(16)
	wd = fWidth*.1
	lt = fWidth*.22
	ht = fHeight*.025
	top = fHeight*.7
	mainForm.RootPane.AddNode(lblName,lt,top,wd,ht)
	lblName.TextColor = fx.Colors.White
	wd = fWidth*.45
	lt = fWidth*.33
	ht = fHeight*.05
	top = fHeight*.69
	mainForm.RootPane.AddNode(txtName,lt,top,wd,ht)
	wd = fWidth*.2
	lt = fWidth*.16
	ht = fHeight*.025
	top = fHeight*.79
	mainForm.RootPane.AddNode(lblDob,lt,top,wd,ht)
	lblDob.TextColor = fx.Colors.White	
	wd = fWidth*.2
	lt = fWidth*.33
	ht = fHeight*.05
	top = fHeight*.78
	mainForm.RootPane.AddNode(txtDob, lt, top, wd, ht)
	mnuButton.Style = "-fx-text-fill : cyan;"
	btnExit.Style = "-fx-text-fill : red;"
	
	'set column widths
	wd = fWidth*.56
	colWd = wd*.4
	tvPeople.SetColumnWidth(0,colWd)
	colWd = wd*.3
	tvPeople.SetColumnWidth(1,colWd)
	colWd = wd*.29
	tvPeople.SetColumnWidth(2,colWd)	

	'set timer to allow time for tvPeople size to change
	tvTimer.Enabled = True

End Sub
Sub tvTimer_tick
	tvTimer.Enabled = False
	clTv.setMaxRows(tvPeople.height)
	addTvData
End Sub
Sub imgEnd_MouseClicked (EventData As MouseEvent)
	Dim s As String
	Dim count As Int
	Dim rsCount As ResultSet
	s = "select count(*) as recs from people"
	rsCount = Main.sLite.db.ExecQuery(s)
	rsCount.NextRow
	count = rsCount.GetString("recs")
	dbOffset = count - clTv.maxrows
	If dbOffset < 0 Then
		dbOffset = 0
	End If
	addTvData	
End Sub
Sub imgNext_MouseClicked (EventData As MouseEvent)
	Dim s As String
	Dim count As Int
	Dim rsCount As ResultSet
	s = "select count(*) as recs from people"
	rsCount = Main.sLite.db.ExecQuery(s)
	count = rsCount.GetString("recs")
	dbOffset = dbOffset + clTv.maxrows
	If dbOffset >= count Then
		imgEnd_MouseClicked(Null)
	End If
	addTvData
End Sub
Sub imgPrev_MouseClicked (EventData As MouseEvent)
	dbOffset = dbOffset - clTv.maxrows
	If dbOffset < 0 Then
		dbOffset = 0
	End If
	addTvData
End Sub
Sub imgBegin_MouseClicked (EventData As MouseEvent)
	dbOffset = 0
	addTvData
End Sub
